<template>
    <div>

        <div>
            <b-modal ref="putmodal" hide-footer id="modal-1" title="BootstrapVue">
                <div class="form-group">
                    <form method="put" @submit.prevent="putFach(fachUpdate.id)">
                        <label for="">Fachunterricht wählen</label>
                        <select class="form-control form-select-lg mb-3" name="TrainerAnstellung" id=""
                            v-model="fachUpdate.fachUnterricht">
                            <option value="JAVA">Java</option>
                            <option value="WEB">Web</option>
                            <option value="DB">Datenbanken</option>
                            <option value="WINDOWS">Windows</option>
                            <option value="LINUX">Linux</option>
                            <option value="KARRIERECOACHING">Karrierecoaching</option>
                        </select>
                        <input type="text" name="enddatum" id="" placeholder="Fach ID"
                            v-model="fachUpdate.fachBezeichnung" class="form-control"> <br>
                        <button type="submit" class="btn container-fluid btn-info">Speichern</button>
                    </form>
                </div>

            </b-modal>
        </div>

        <table class="table">
            <th>ID</th>
            <th>Fachunterricht</th>
            <th>fachBezeichnung</th>
            <th>Wird von Trainer unterrichtet</th>
            <th></th>
            <tr v-for="(fach, id) in alleFaecher" :key='id'>
                <td>{{ fach.id }}</td>
                <td>{{ fach.fachUnterricht }}</td>
                <td>{{ fach.fachBezeichnung }}</td>
                <td>
                    <table class="table thead-light">
                        <th>Name</th>
                        <th>ID</th>
                        <tr v-for="(trainer, id) in fach.trainerInSet" :key='id'>
                            <td>{{ trainer.name }}</td>
                            <td>{{ trainer.id }}</td>
                        </tr>
                    </table>
                </td>
                <td>
                    <button type="button" class="btn btn-danger m-1" @click="deleteFach(fach.id)">X</button>
                    <button type="button" class="btn btn-primary m-1" v-b-modal.modal-1
                        @click="editFach(fach)">O</button>
                </td>
            </tr>
        </table>
    </div>
</template>

<script>
export default {
    name: 'FachSeite',
    data() {
        return {

            fachUpdate: {
                fachUnterricht: '',
                fachBezeichnung: '',
                id: ''
            }

        };
    },

    computed: {
        alleFaecher() {
            return this.$store.state.alleFaecher
        },
    },

    components: {
    },

    mounted() {
        this.$store.dispatch('getAlleFaecher');
    },

    methods: {

        async deleteFach(id) {
            const deleteFach = this.$store.dispatch('deleteFach', id)
            console.log(deleteFach);
        },

        async editFach(fach) {
            this.fachUpdate.fachUnterricht = fach.fachUnterricht;
            this.fachUpdate.fachBezeichnung = fach.fachBezeichnung;
            this.fachUpdate.id = fach.id;
        },

        async putFach() {
            console.log(this.fachUpdate)
            this.$store.dispatch("putFach", this.fachUpdate);
            this.hideModal();
        },

        hideModal() {
            this.$refs['putmodal'].hide();
        }
    }
}
</script>